Bug 258381 - mke2fs rejects feature options listed by tune2fs
mke2fs rejects feature options listed by tune2fs
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: e2fsprogs (Show other bugs)
7
i386 Linux
medium Severity low
: ---
: ---
Assigned To: Eric Sandeen
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-08-27 19:16 EDT by John Reiser
Modified: 2008-02-29 11:42 EST (History)
1 user (show)

See Also:
Fixed In Version: 1.40.7.1
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-02-29 11:42:21 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description John Reiser 2007-08-27 19:16:12 EDT
Description of problem:
When creating a new filesystem, mke2fs rejects feature options that are listed
by tune2fs as present on an existing ext3 filesystem.

Version-Release number of selected component (if applicable):
e2fsprogs-1.40.2-2.fc7


How reproducible:
always

Steps to Reproduce:
1./sbin/tune2fs -l /dev/sda11  # note Options listed in ouput:
Filesystem features:      has_journal ext_attr resize_inode dir_index filetype
needs_recovery sparse_super large_file

2./sbin/mke2fs -j -O
has_journal,ext_attr,resize_inode,dir_index,filetype,sparse_super,large_file
/dev/sda15   # try to use same options as listed by tune2fs

3.
  
Actual results:  (with 3 different lists)
Invalid filesystem option set:
has_journal,ext_attr,resize_inode,dir_index,filetype,sparse_super,large_file
Invalid filesystem option set:
ext_attr,resize_inode,dir_index,filetype,sparse_super,large_file
Invalid filesystem option set:
resize_inode,dir_index,filetype,sparse_super,large_file


Expected results:
No complaints, and filesystem created with specified feature options.

If the list is invalid, then give an explicit reason why, with enough
information to edit the list to result in a valid option list.  For instance,
"option foo is incompatible with option bar", or "option baz is unknown".

Additional info:
The existing filesystem on /dev/sda11 was created by anaconda with default
parameters during an install.  I wanted the same features on a new filesystem
created after install.  These are not the default features of mke2fs, not even
"mke2fs -j".

The option "large_file" does not appear in the manual page "man mke2fs".
Comment 1 Eric Sandeen 2007-08-28 02:33:04 EDT
> The option "large_file" does not appear in the manual page "man mke2fs".

The option "large_file" is also the option which is causing you trouble when you
try to feed it to mkfs.ext3:

[root@bear-05 ~]# mke2fs -j -O
has_journal,resize_inode,dir_index,filetype,sparse_super,large_file
/dev/mapper/testvol-test1 
mke2fs 1.39 (29-May-2006)
Invalid filesystem option set:
has_journal,resize_inode,dir_index,filetype,sparse_super,large_file

[root@bear-05 ~]# mke2fs -j -O
has_journal,resize_inode,dir_index,filetype,sparse_super
/dev/mapper/testvol-test1 mke2fs 1.39 (29-May-2006)
Filesystem label=
OS type: Linux
<snip>
This filesystem will be automatically checked every 31 mounts or
180 days, whichever comes first.  Use tune2fs -c or -i to override.

But, large_file is set anyway:

[root@bear-05 ~]# tune2fs -l /dev/mapper/testvol-test1 | grep feature
Filesystem features:      has_journal resize_inode dir_index filetype
sparse_super large_file

This is probably an oversight, but I'll double-check.  I agree that a message
about why the feature set was rejected would be a good idea.

Thanks,

-Eric
Comment 2 Eric Sandeen 2008-02-29 11:42:21 EST
On its way to rawhide via e2fsprogs-1.40.7-1

From the changelog:

Allow mke2fs and tune2fs manipulate the large_file feature.
Previously we just let the kernel and e2fsck do this automatically,
but e2fsck will no longer automatically clear the large_file feature.
It still isn't really necessary to worry about this feature flag
explicitly, but some users seem to care.  (Addresses Red Hat Bugzilla:
#258381)

I think Ted is also planning to print more info about which option was rejected,
if/when that is still necessary.

Note You need to log in before you can comment on or make changes to this bug.